// This is the high level specification model of 
// instruction length decoder.

   Const
                N: 		12; -- buffer size
		P:		8; -- Byte size
		CON_ALL_0:       "b0000000000000000";
 		-- Prefix
		Pre66h:         "b01100110";	
		Pre67h:         "b01100111";
		-- ESCAPE
		ESCAPE:         "b00001111";

		-- one opcode byte instructions
		instr_AAA:               "b00110111";

                instr_ADC_000100xx:      "b000100xx";
		instr_ADC_00010101:      "b00010101";
		instr_ADC_00010100:      "b00010100";
                instr_BSWAP:             "b11001xxx";

                instr_ADC_100000x1:      "b100000x1";
		instr_ADC_100000x0:      "b100000x0";

   Var
                -- input
         InputPin
                wrapin: bit[N];
                parcel: bit[N*P];
                nextparcel: bit[N*P];
                                                                                         
                -- output
         OutputPin
                wrapout: bit[N];
                ild_begin:   bit[N];
                ild_end:     bit[N];
                                                                                         
                -- global temp variable
         TempPin
                wrap:    int;
                bitpair: bit[P];
                address_mode_32: bit;
                oprand_mode_32: bit;

                flag: bit;
		ret : bit;
		i : int;
                j : int;

		read_one_PAIR: int;
		mod_reg_rm: int;

		_cutpt_tmp_bit0: bit;
	 	_cutpt_tmp_bit1: bit;	
		_cutpt_tmp_bit2: bit;
                _cutpt_tmp_bit3: bit;
                _cutpt_tmp_bit4: bit;
                _cutpt_tmp_bit5: bit;
 		
                mod_A: bit;

                _cutpt_tmp_int0: int;

		pref_gr1: bit;
                pref_gr2: bit;
                pref_gr3: bit;
                pref_gr4: bit;

                _cutpt_antecedent: bit;

         antecedent
                _cutpt_antecedent; 

   PartitionVar
	 	wrap; -- any new value of wrap at cutpt will be a separated state
   Softcutpt
		Vertex_main_3_cutpt;
   StartVertex
 		Vertex_main;
   EndVertex
  		Vertex_main_return;

Vertex_main -> Vertex_init_decoder_0
Begin
 ==>
  address_mode_32 := "b1";
  oprand_mode_32 := "b1";
  flag := "b0";
  mod_A := "b0";
  i := 0;
  wrap := 0;
End


Vertex_init_decoder_0 -> Vertex_init_decoder_1
Begin
  _cutpt_antecedent := i<N;
 ==>
End

Vertex_init_decoder_0 -> Vertex_init_decoder_check
Begin
  _cutpt_antecedent := i >= N;
 ==>
  ret := flag;
End

Vertex_init_decoder_1 -> Vertex_init_decoder_continue
Begin
  _cutpt_tmp_bit0 := wrapin[i] == "b1";
  _cutpt_tmp_bit1 := flag == "b0";
  _cutpt_antecedent := _cutpt_tmp_bit0 && _cutpt_tmp_bit1;
 ==>
  flag := "b1";
End

Vertex_init_decoder_1 -> Vertex_init_decoder_continue
Begin
  _cutpt_antecedent := wrapin[i] == "b0"; 
 ==>
End

Vertex_init_decoder_continue -> Vertex_init_decoder_0
Begin
 ==>
  i := i + 1;
End

-- if ret is 1, return, else stuck there.
Vertex_init_decoder_check -> main
Begin
  _cutpt_antecedent := ret == "b1";
 ==>
End

--main

main -> Vertex_main_1
Begin
 ==>
End

Vertex_main_1 -> Vertex_main_1
Begin
  -- wrapin[wrap] == 0
  _cutpt_antecedent := wrapin[wrap] == "b0";
 ==>
  wrap := wrap + 1;
End

Vertex_main_1 -> Vertex_main_2
Begin
  -- wrapin[wrap] != 0
  _cutpt_antecedent := wrapin[wrap] == "b1";
 ==>
End

Vertex_main_2 -> Vertex_main_3
Begin
  -- wrap <= 0
  _cutpt_antecedent := wrap <= 0;
 ==>
End 

Vertex_main_2 -> Vertex_main_3
Begin
  --wrap > 0
  _cutpt_antecedent := wrap > 0;
 ==>
  _cutpt_tmp_int0 :=  wrap - 1;
  ild_end[_cutpt_tmp_int0] := "b1";
End

Vertex_main_3 -> Vertex_main_3_cutpt
Begin
  _cutpt_antecedent := wrap < N;
 ==>
  ild_begin[wrap] := "b1";
End

-- handle_prefix only called once..so no version 
Vertex_main_3_cutpt -> handle_prefix
Begin
 ==>
End

handle_prefix_return -> Vertex_main_44
Begin
 ==>
End

Vertex_main_44 -> read_one_PAIR
Begin
 _cutpt_antecedent := ret =="b1";
 ==>
  read_one_PAIR := 10;
  wrap := wrap +1;
End

read_one_PAIR_return -> Vertex_main_4
Begin
 _cutpt_antecedent := read_one_PAIR == 10;
 ==>
End

Vertex_main_44 -> Vertex_main_4
Begin
 _cutpt_antecedent := ret =="b0";
 ==>
End



Vertex_main_3 -> Vertex_main_end_while_0
Begin
  _cutpt_antecedent := wrap >= N;
 ==>
End

-- one_byte_opcode is called only once
Vertex_main_4 -> one_byte_opcode
Begin
  _cutpt_tmp_bit0 := bitpair[0..7] == ESCAPE;
  _cutpt_antecedent := !_cutpt_tmp_bit0;
 ==>
End

one_byte_opcode_return -> Vertex_main_31
Begin
 ==>
End

-- two_byte_opcode is called only once
Vertex_main_4 -> read_one_PAIR
Begin
 _cutpt_antecedent := bitpair[0..7] == ESCAPE;
 ==>
  read_one_PAIR := 11;
  wrap := wrap + 1;
End

read_one_PAIR_return -> two_byte_opcode
Begin
  _cutpt_antecedent := read_one_PAIR == 11;
 ==>
End

two_byte_opcode_return -> Vertex_main_31
Begin
 ==>
End

Vertex_main_31 -> Vertex_main_3
Begin
  _cutpt_tmp_int0 := wrap -1;
  _cutpt_antecedent :=_cutpt_tmp_int0 < N;
 ==>
  ild_end[_cutpt_tmp_int0] := "b1";
End

Vertex_main_31 -> Vertex_main_3
Begin
  _cutpt_tmp_int0 := wrap -1;
  _cutpt_antecedent :=_cutpt_tmp_int0 >= N;
 ==>
End


Vertex_main_end_while_0 -> Vertex_main_return
Begin
 ==>
  _cutpt_tmp_int0 := wrap-N;
  wrapout[_cutpt_tmp_int0] := "b1";
End


--*****************read_one_PAIR*******************************************
--This procedure is called many times
read_one_PAIR -> Vertex_r1
Begin
  _cutpt_antecedent := wrap < N;
 ==>
  i := 0;
End

read_one_PAIR -> Vertex_r2
Begin
  _cutpt_antecedent := wrap >= N;
 ==>
  i := 0;
End


Vertex_r1 -> Vertex_r1
Begin
  _cutpt_antecedent := i < 8;
 ==>
  _cutpt_tmp_int0 := wrap * 8;
  _cutpt_tmp_int0 := _cutpt_tmp_int0 + i;
  bitpair[i]:= parcel[_cutpt_tmp_int0];
  i := i + 1;
End

Vertex_r2 -> Vertex_r2
Begin
  _cutpt_antecedent := i < 8;
 ==>
  _cutpt_tmp_int0 := wrap - N;
  _cutpt_tmp_int0 := _cutpt_tmp_int0 * 8;
  _cutpt_tmp_int0 := _cutpt_tmp_int0 + i; 
  bitpair[i] := nextparcel[_cutpt_tmp_int0];
  i := i + 1;
End

Vertex_r1 -> read_one_PAIR_return
Begin
  _cutpt_antecedent := i >= 8;
 ==>
End 

Vertex_r2 -> read_one_PAIR_return
Begin
  _cutpt_antecedent := i >= 8;
 ==>
End 
--******************************************************************************



-- *****************bit32_addressing_ModRM*****************************

-- Mod = 00
bit32_addressing_ModRM -> Vertex_b32_mod00
Begin
  _cutpt_antecedent := bitpair[0..1] == "b00";
 ==>
End

Vertex_b32_mod00 -> bit32_addressing_ModRM_return
Begin
  _cutpt_antecedent := bitpair[5] == "b0";
 ==>
End

Vertex_b32_mod00 -> bit32_addressing_ModRM_return
Begin
  _cutpt_antecedent := bitpair[5..6] == "b11";
 ==>
End

Vertex_b32_mod00 -> bit32_addressing_ModRM_return
Begin
  _cutpt_antecedent := bitpair[5..7] == "b101";
 ==>
  wrap := wrap + 4;
End

--SIB byte follows
Vertex_b32_mod00 -> read_one_PAIR
Begin
_cutpt_antecedent := bitpair[5..7] == "b100";
 ==>
 read_one_PAIR := 0;
End

read_one_PAIR_return -> Vertex_b32_SIB00
Begin
 _cutpt_antecedent := read_one_PAIR == 0;
 ==>
 wrap := wrap + 1;
End


Vertex_b32_SIB00 -> Vertex_b32_SIB00_1
Begin
  _cutpt_tmp_bit0 := bitpair[2..4] == "b100";
  _cutpt_antecedent := !_cutpt_tmp_bit0;
 ==>
End 

Vertex_b32_SIB00_1 -> bit32_addressing_ModRM_return
Begin
  _cutpt_antecedent := bitpair[5..7] == "b101";
 ==>
  wrap := wrap + 4;
End

Vertex_b32_SIB00_1 -> bit32_addressing_ModRM_return
Begin
  _cutpt_tmp_bit0 := bitpair[5..7] == "b101";
  _cutpt_antecedent := !_cutpt_tmp_bit0;
 ==>
End

-- 01
bit32_addressing_ModRM -> Vertex_b32_mod01
Begin
  _cutpt_antecedent := bitpair[0..1] == "b01";
 ==>
End

Vertex_b32_mod01 -> bit32_addressing_ModRM_return
Begin
  _cutpt_tmp_bit0 := bitpair[5..7] == "b100";
  _cutpt_antecedent := !_cutpt_tmp_bit0;
 ==>
  wrap := wrap + 1;
End

//SIB byte follows
Vertex_b32_mod01 -> read_one_PAIR
Begin
  _cutpt_antecedent := bitpair[5..7] == "b100";
 ==>
 read_one_PAIR := 1;
End

read_one_PAIR_return -> Vertex_b32_SIB01
Begin
 _cutpt_antecedent := read_one_PAIR == 1;
 ==>
 wrap := wrap + 1;
End


Vertex_b32_SIB01 -> bit32_addressing_ModRM_return
Begin
  _cutpt_tmp_bit0 := bitpair[2..4] == "b100";
  _cutpt_antecedent := !_cutpt_tmp_bit0;
 ==>
  wrap := wrap + 1;
End 
 

-- 10
bit32_addressing_ModRM -> Vertex_b32_mod10
Begin
  _cutpt_antecedent := bitpair[0..1] == "b10";
 ==>
End

Vertex_b32_mod10 -> bit32_addressing_ModRM_return
Begin
  _cutpt_tmp_bit0 := bitpair[5..7] == "b100";
  _cutpt_antecedent := !_cutpt_tmp_bit0;
 ==>
  wrap := wrap + 4;
End

//SIB byte follows
Vertex_b32_mod10 -> read_one_PAIR
Begin
  _cutpt_antecedent := bitpair[5..7] == "b100";
 ==>
 read_one_PAIR := 2;
End

read_one_PAIR_return -> Vertex_b32_SIB10
Begin
 _cutpt_antecedent := read_one_PAIR == 2;
==>
 wrap := wrap + 1;
End
                                                                                              
Vertex_b32_SIB10 -> bit32_addressing_ModRM_return
Begin
  _cutpt_tmp_bit0 := bitpair[2..4] == "b100";
  _cutpt_antecedent := !_cutpt_tmp_bit0;
 ==>
  wrap := wrap + 4;
End


bit32_addressing_ModRM -> bit32_addressing_ModRM_return
Begin
  _cutpt_tmp_bit0 := bitpair[0..1] == "b11";
  _cutpt_tmp_bit1 := !mod_A; 
  _cutpt_antecedent := _cutpt_tmp_bit0 && _cutpt_tmp_bit1;
 ==>
End


-- *******************bit16_addressing_ModRM***********************************
bit16_addressing_ModRM -> Vertex_b16_addressing_ModRM_mod00
Begin
  _cutpt_antecedent := bitpair[0..1] == "b00";
 ==>
End
 
Vertex_b16_addressing_ModRM_mod00 -> bit16_addressing_ModRM_return
Begin
  _cutpt_antecedent := bitpair[5..7] == "b110";
 ==>
  wrap := wrap + 2;
End 

Vertex_b16_addressing_ModRM_mod00 -> bit16_addressing_ModRM_return
Begin
  _cutpt_tmp_bit0 := bitpair[5..7] == "b110";
  _cutpt_antecedent := !_cutpt_tmp_bit0;
 ==>
End
 

bit16_addressing_ModRM -> bit16_addressing_ModRM_return
Begin
  _cutpt_antecedent := bitpair[0..1] == "b01";
 ==>
  wrap := wrap + 1;
End

bit16_addressing_ModRM -> bit16_addressing_ModRM_return
Begin
  _cutpt_antecedent := bitpair[0..1] == "b10";
 ==>
  wrap := wrap + 2;
End 

bit16_addressing_ModRM ->bit16_addressing_ModRM_return
Begin
  _cutpt_tmp_bit0 := bitpair[0..1] == "b11";
  _cutpt_tmp_bit1 := !mod_A;
  _cutpt_antecedent := _cutpt_tmp_bit0 && _cutpt_tmp_bit1;
 ==>
End 


-- *********************mod_reg_rm****************************************
mod_reg_rm -> Vertex_mod_reg_rm_0
Begin
 ==>
  wrap := wrap + 1;
End
 
Vertex_mod_reg_rm_0 -> bit32_addressing_ModRM
Begin
  _cutpt_antecedent :=  address_mode_32 == "b1";
 ==>
End 

bit32_addressing_ModRM_return -> mod_reg_rm_return
Begin
 ==>
End


Vertex_mod_reg_rm_0 -> bit16_addressing_ModRM
Begin
  _cutpt_antecedent :=  address_mode_32 == "b0";
 ==>
End 

bit16_addressing_ModRM_return -> mod_reg_rm_return
Begin
 ==>
End

--****************handle_prefix*************************************

handle_prefix -> Vertex_handle_prefix_0
Begin
 ==>
  j := 0;
  oprand_mode_32 := "b1";
  address_mode_32 := "b1";
  pref_gr1 := "b0";
  pref_gr2 := "b0";
  pref_gr3 := "b0";
  pref_gr4 := "b0";
  ret := "b0";
End

-- have 4 valid prefixes
Vertex_handle_prefix_0 -> handle_prefix_return
Begin
 _cutpt_antecedent := j == 4;
 ==>
 ret := "b1";
End

Vertex_handle_prefix_0 -> read_one_PAIR
Begin
  _cutpt_antecedent := j < 4;
 ==>
  read_one_PAIR := 3;
End

read_one_PAIR_return -> Vertex_handle_prefix_1
Begin
 _cutpt_antecedent := read_one_PAIR == 3;
==>
End
  
Vertex_handle_prefix_1 -> Vertex_handle_prefix_gr3
Begin
  _cutpt_antecedent := bitpair[0..7] == Pre66h;
 ==>
End 

Vertex_handle_prefix_gr3 -> Vertex_handle_prefix_continue
Begin
  _cutpt_antecedent :=  pref_gr3 == "b0";
 ==>
  wrap := wrap +1;
  pref_gr3 := "b1";
  oprand_mode_32 := !oprand_mode_32;
End 

Vertex_handle_prefix_1 -> Vertex_handle_prefix_gr4
Begin
  _cutpt_antecedent := bitpair[0..7] == Pre67h;
 ==>
End
 
Vertex_handle_prefix_gr4 -> Vertex_handle_prefix_continue
Begin
  _cutpt_antecedent :=  pref_gr4 == "b0";
 ==>
  wrap := wrap +1;
  pref_gr4 := "b1";
  address_mode_32 := !address_mode_32;
End 
                                                                                              
Vertex_handle_prefix_continue -> Vertex_handle_prefix_0
Begin
 ==>
 j := j + 1;
End 


-- It is not a prefix. a filter
Vertex_handle_prefix_1 -> handle_prefix_return
Begin
  _cutpt_tmp_bit0 := bitpair[0..7] == Pre66h;
  _cutpt_tmp_bit1 := bitpair[0..7] == Pre67h;
  _cutpt_tmp_bit2 := _cutpt_tmp_bit0 || _cutpt_tmp_bit1;

  _cutpt_antecedent :=  !_cutpt_tmp_bit2;
 ==>
   ret := "b0";
End

--********************one_byte_opcode***************************************
one_byte_opcode -> Vertex_one_byte_opcode
Begin
 ==>
 wrap := wrap + 1;
End

--instr_AAA
Vertex_one_byte_opcode -> one_byte_opcode_return
Begin
  _cutpt_antecedent := bitpair[0..7] == instr_AAA;
 ==>
End 


--instr_ADC_000100sw
Vertex_one_byte_opcode -> read_one_PAIR
Begin
 _cutpt_antecedent := bitpair[0..7] == instr_ADC_000100xx;
 ==>
 read_one_PAIR := 4;
End

read_one_PAIR_return -> mod_reg_rm
Begin
 _cutpt_antecedent := read_one_PAIR == 4;
==>
  mod_reg_rm := 0;
  mod_A := "b0";
End
                                                                                                                  
mod_reg_rm_return -> one_byte_opcode_return
Begin
  _cutpt_antecedent := mod_reg_rm == 0;
==>
End
--done instr_ADC_000100sw



Vertex_one_byte_opcode -> Vertex_one_byte_opcode_instr_mod
Begin
  _cutpt_antecedent := bitpair[0..7] == instr_ADC_00010101;
 ==>
End 

-- w = 1, word or double-word
Vertex_one_byte_opcode_instr_mod -> one_byte_opcode_return
Begin
  _cutpt_antecedent := oprand_mode_32 == "b1";
 ==>
  wrap := wrap + 4;
End

Vertex_one_byte_opcode_instr_mod -> one_byte_opcode_return
Begin
  _cutpt_antecedent := oprand_mode_32 == "b0";
 ==>
  wrap  := wrap + 2;
End

-- w = 0, byte
Vertex_one_byte_opcode -> one_byte_opcode_return
Begin
 _cutpt_antecedent := bitpair[0..7] == instr_ADC_00010100;
 ==>
 wrap  := wrap + 1;
End

--instr_ADC_100000x1:      "b100000x1"; w = 1
Vertex_one_byte_opcode -> read_one_PAIR
Begin
 _cutpt_antecedent := bitpair[0..7] == instr_ADC_100000x1;
 ==>
 read_one_PAIR := 5;
End
                                                                                 
read_one_PAIR_return -> mod_reg_rm
Begin
  _cutpt_tmp_bit0 := bitpair[2..4] == "b010";
  _cutpt_tmp_bit1 := read_one_PAIR == 5;
 _cutpt_antecedent := _cutpt_tmp_bit0 && _cutpt_tmp_bit1;
==>
  mod_reg_rm := 1;
  mod_A := "b0";
End
                                                                                 
                                                                                 
mod_reg_rm_return -> Vertex_one_byte_opcode_instr_mod
Begin
  _cutpt_antecedent := mod_reg_rm == 1;
==>
End

--done instr_ADC_100000x1

--instr_ADC_100000x0:      "b100000x0"; w = 0

Vertex_one_byte_opcode -> read_one_PAIR
Begin
 _cutpt_antecedent := bitpair[0..7] == instr_ADC_100000x0;
 ==>
 read_one_PAIR := 6;
End
                                                                                 
read_one_PAIR_return -> mod_reg_rm
Begin
  _cutpt_tmp_bit0 := bitpair[2..4] == "b010";
  _cutpt_tmp_bit1 := read_one_PAIR == 6;
 _cutpt_antecedent := _cutpt_tmp_bit0 && _cutpt_tmp_bit1;
==>
  mod_reg_rm := 2;
  mod_A := "b0";
End
                                                                                 
                                                                                 
mod_reg_rm_return -> one_byte_opcode_return
Begin
  _cutpt_antecedent := mod_reg_rm == 2;
==>
  wrap  := wrap + 1;
End

--done instr_ADC_100000x0




--*****************two_byte_opcode********************************************
two_byte_opcode -> Vertex_two_byte_opcode
Begin
 ==>
 wrap := wrap +1;
End

Vertex_two_byte_opcode -> two_byte_opcode_return
Begin
  _cutpt_antecedent := bitpair[0..7] == instr_BSWAP;
 ==>
End 

--****************END OF EDGES***************************************************

